""" Petit script, pour monitor l'arduino !
"""

import serial

from time import sleep
from datetime import datetime

from influxdb_client import InfluxDBClient, client, domain, Point

# /dev/ttyACM1
PORT = '/dev/serial/by-id/usb-Arduino__www.arduino.org__Arduino_Due_Prog._Port_7543134333435181C0F1-if00'
BRATE = 115200

URL = "http://127.0.0.1:8086/"
TOKEN = "NnB9OxRT1fHETIx3UH98CFwl_bUmQ9yxTcTSMGC0sGQkbwzmOUJF4HDZgJ4ddzjrNT-uUOmwcHET2Sj95MQpzg=="
ORG = "Strontium"

if __name__ == "__main__":
    client_db = InfluxDBClient(url=URL, token=TOKEN, org=ORG)
    
    query_api = client_db.query_api()
    db_write_api = client_db.write_api(write_options=client.write_api.SYNCHRONOUS)

    def db_write_point(p):
        p.time(datetime.utcnow(), write_precision=domain.write_precision.WritePrecision.MS)
        db_write_api.write(bucket="lab", record=p)

    s = serial.Serial(PORT, BRATE)

    while True:

        line = s.readline().decode('utf-8')
        if len(line) < 2:
            continue

        # format :
        # TI:···;TO:···;CMD:···;SETI:···

        fields = line[:-2].split(';')
        if len(fields) != 4:
            continue

        values = {}
        for field in fields:
            k,v = field.split(':')
            values[k] = float(v)
        print(values)

        db_write_point(Point("asservissement").field("vanne", values['CMD']))
        db_write_point(Point("roomtemp").tag("where","sciencetable_arduino").field("tempC", values['TO']))
        db_write_point(Point("roomtemp").tag("where","airsock").field("tempC", values['TI']))
        db_write_point(Point("roomtemp").tag("where","consigne airsock").field("tempC", values['SETI']))
